#include <iostream>
#include <sstream>
#include <string>
#include <cstdlib>
#include <cmath>

using namespace std;

int main() {
    int n;
    int i;
    int p;
    int k;
    int m;
    int j;
    int a[100];
    int b[100];
    string c[100];
    
    cin >> n;
    p = 0;
    for (i = 1; i <= n - 1; i++) {
        cin >> a[i];
        cin >> b[i];
        cin >> c[i];
    }
    for (j = 1; j <= n - 1; j++) {
        if (c[j] == "S") {
            for (k = 1; k <= n - 1; k++) {
                if (a[k] == b[j]) {
                    if (c[k] == "I") {
                        for (m = 1; m <= n - 1; m++) {
                            if (a[m] == b[k]) {
                                if (c[m] == "O") {
                                    p = p + 1;
                                }
                            } else {
                                if (a[m] == a[k]) {
                                    if (c[m] == "O") {
                                        p = p + 1;
                                    }
                                }
                            }
                        }
                    }
                } else {
                    if (a[k] == a[j]) {
                        for (m = 1; m <= n - 1; m++) {
                            if (a[m] == b[k]) {
                                if (c[m] == "O") {
                                    p = p + 1;
                                }
                            } else {
                                if (a[m] == a[k]) {
                                    if (c[m] == "O") {
                                        p = p + 1;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    cout << p << endl;
    return 0;
}